/*
    OpenGUI - Drawing & Windowing library

    Copyright (C) 1996,2004  Marian Krivos

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    nezmar@atlas.sk

  $Id: bench.cpp,v 1.15 2004/08/25 21:16:10 majo Exp $

  $Log: bench.cpp,v $
  Revision 1.15  2004/08/25 21:16:10  majo
  priebezne zmeny

  Revision 1.14  2004/04/27 17:39:19  majo
  *

  Revision 1.13  2004/04/16 08:58:19  majo
  added FGRadioGroup::SetUserData(void *)

  Revision 1.12  2004/03/24 17:13:58  majo
  added FGXColor
  added FGColorPicker

  Revision 1.11  2004/03/17 21:19:12  majo
  added FGColor, FGImage

  Revision 1.10  2004/03/09 20:23:58  majo
  added FGImage
  improved FGColor & and its docs

  Revision 1.9  2004/03/03 20:12:39  majo
  added class FGColor
  fixed Solaris compiling

  Revision 1.8  2004/03/01 15:19:15  majo
  _GTRANSP -> _GCOLORKEY
  added _GTRANSPARENT

  Revision 1.7  2004/02/29 19:58:19  majo
  devel state

  Revision 1.6  2004/02/23 20:08:01  majo
  all classes are with prefix FG* on now
  polygon functions uses FGPointArray from now
  class GuiEvent is renamed to FGEvent
  some by parameters overloaded methods was removed (class FGWindow)
  many other small changes

  Revision 1.5  2004/02/12 17:52:11  majo
  *

  Revision 1.4  2004/02/10 16:18:59  majo
  fixed compile warnings

  Revision 1.3  2004/02/04 17:52:31  majo
  fixed TabPages and Control::draw() & other similar code

  Revision 1.2  2004/01/31 10:06:58  majo
  Added Window::AddPushButton(int x, int y, int w, int h, char* name, int key, DrawBuffer* background, ControlCall fnc);

  Revision 1.1.1.1  2004/01/22 16:25:08  majo
  initial release

*/

#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <stdarg.h>
#include "config.h"
#include "fastgl.h"
#include "widgets.h"
#include "_fastgl.h"
#include "drivers.h"
//#include "fgttf.h"
//#include "fglmesa.h"

//#include <ipp.h>

#ifdef _MSC_VER
#define	random rand
#define	srandom srand
#undef _WIN32
#endif

extern int rnd(int);
#ifndef _WIN32
#define rnd(a) (random()%(a+1))  // macro for randomize fnc
#else
#define rnd(a) (random(a))  // macro for randomize fnc
#endif

#ifdef FG_NAMESPACE
using namespace fgl;
#endif

int a, b;
char s[80];

FGWindow *w1, *w2;
FGButtonGroup *grp;

int cas()
{
	static int a = 0, b;

	b = a;
	return ((a = clock()) - b);
}

int test3()
{
	int i, j, f, c,
		w=w1->GetWW(),
		h=w1->GetHW();

	f = clock();
	for (j = 0; j < 6000; j++)
	{
		w1->WindowFillEllipse(rnd(w1->GetW()), rnd(w1->GetH()), rnd(100), rnd(50), rnd(255));
		w1->WindowDrawEllipse(rnd(w1->GetW()), rnd(w1->GetH()), rnd(100), rnd(50), rnd(255));
		w1->WindowText(rnd(w1->GetW()), rnd(w1->GetH()), "Hello", rnd(255), rnd(255));
		w1->WindowBox(rnd(w1->GetW()), rnd(w1->GetH()), 40, 30,rnd(255));
//		cApp->Yield();
	}
	for (j = 0; j < h; j++)
	{
		for (i = 0; i < w; i++)
		{
			w1->WindowPixel(i, j, i + j);
		}
	}

  FGPoint polygon[10];
  for (j=0;j<100;j++)
  {
    int npoints = rand() % 7 + 3;
    for (i=0; i<npoints; i++) {
      polygon[i].x = rand() % w;
      polygon[i].y = rand() % h;
    }
//    FGPixel color = CreateColor(rand() % 256, rand() % 256, rand() % 256, 16);
    w1->WindowFillPolygon( FGPointArray(npoints,polygon), rand());
  }
//	printf("cas pred printf=%d\n", clock());
	w1->set_colors(0, CWHITE);
	for (j = 0; j < 6000; j++)
	{
		c=rand()&127;
		if (c=='\n') c=12;
		w1->printf("%c", c);
	}
//	printf("cas po printf=%d\n", clock());

	for (j = 0; j < 600; j++)
	{
		w1->WindowLine(rnd(w1->GetWW()+100), rnd(w1->GetHW()), rnd(300), rnd(300), rnd(0xffffff));
	}
//	graph_change_mode(1024,768);
	return clock() - f;
}

void test(CallBack)
{
	FGWindow *w = FGWindow::GetCurrent();

	cas();
	a = test3();
	sprintf(s, "Graph WinMark - %d", a);
	w->WindowText(20, 180, s);
}


void filesel(char *s,FGFileDialog *f)
{
	char t[512];
	f->BuildRelativePathname(t);
	printf("Selected file: abs=%s, dir=%s, rel=%s\n",s,f->GetDir(),t);
	printf("Test to replace %d\n", f->TestForOverwrite());

	FILE* fp = fopen(s,"r");
	if (fp) printf("success\n");
}

void ss(int)
{}

void tproc(FGEvent *p)
{
	if (p->GetType() == MOVEEVENT)
	{
		gprintf(-1, 0, 10,10, "--- %6d %6d ---", p->GetX(), p->GetY() );
	}
}

int app(FGEvent *p)
{
	switch(p->GetType())
	{
		case KEYEVENT:
printf("    busy start ...", a);
			FGApp::GetRootWindow()->WindowBox(0,0,2000,2000,CRED);
			delay(90);
printf(" end\n", a);

			break;
	}
	return 0;
}

void timer(int a)
{
	printf("timer %d\a\n", a);
}

void klavesy(void)
{
	if (w1) w1->printf(10,10,"%d %d %d", FGApp::IsShift(), FGApp::IsCtrl(), FGApp::IsAlt());
    delay(1);
}

int main(int argc, char **argv)
{
	int aa=0, aaz, i;
    FGColor pick(FGColor::pink);
//	const IppLibraryVersion *c = ippGetLibVersion(); printf("Name: %s\n", c->Name);
	FGApp::test_mmx();
	FGApp MyApp(3,argc,argv,0,APP_ALL);

    FGColorPicker picker(&pick);

	FGPoint pp0, pp1(5,6);
	FGRect rr0, rr1(0,0,4,5);
	FGPointArray pa0, pa1(1,&pp1);
/*
	FGDialog error("error no. %d", 3);
	error.ShowOk();
	error.ShowYesNo();
	error.ShowRetryIgnoreCancel();
*/
	cCfg->WriteInt("COM_BaudRate_110", aa);
	cCfg->ReadInt("COM_BaudRate_110");
	FGWindow * root =MyApp.GetRootWindow();
	root->set_fcolor(CGRAY3);
	for(int j=0; j<GetYRes(); j+=8) for(i=0; i<GetXRes(); i+=8)
	{
		root->WindowPixel(i,j);
	}

	FGControl *eb;
//	int ff = register_font((unsigned char*)_12x24, 12, 24, 256, 0);
//	set_font(ff);
	(void)new FGWindow(&w1, 20, 20, X_width-40, Y_width-40, "Test Window", tproc, CBLACK, CGRAY1, WFRAMED|WMINIMIZE|WTITLED);
	(void)new FGWindow(&w2, X_width-440, Y_width-340, 400, 300, "Main Window", 0, 0, FGColor(FGColor::coral),
	WNOTEBOOK |
	WSIZEABLE | WMENU | WTITLED | WNOICON|WSTATUSBAR|WMINIMIZE|WFASTMOVE|WLASTFOCUS);
	new FGWindow(0,100,100,4,4,"dfsaf");
	FGEditBox *ee = w2->AddEditBox(10,10,50,50,"xxx",0,&aa);
	w2->AddImage(40,40, ee);
//	(new FGUpDown(ee, 2))->Disable();
//	w1->WindowSetWorkRect(4,23,2000,2000);

	FGApp::GetRootWindow()->WindowPutBitmap(0, 0, 0,0,X_width, Y_width,w2);

	w2->AddBaseMenu("File ", 'F');
	w2->AddBaseMenu("Edit ", 'E');
	eb = w2->AddPushButton(320, 10, 60, 24, "Test", 'T', test);

//	set_font(ff);
	sprintf(s, " !@12 Resolution %dx%dx%d", X_width, Y_width, get_colordepth());
	w2->WindowText(20, 50, s);
	w2->WindowStatusBar(0, "asd");

	w1->WindowFillCircle(100,100,50,CBLACK+6);
	int mz[][2]={{62,186},{135,150},{221,197},{377,125},{231,25},{150,85},{10,18},{62,186}};
	FGPointArray mzv(8, mz);
	w1->WindowFillPolygon(mzv,CRED);
	w1->WindowDrawPolygon(mzv,CRED);
	w1->WindowPatternLine(0, 0, 300, 0, &PatternDot);
	w1->WindowPatternLine(0, 20, 300, 20, &PatternSlashDot);
	w1->WindowPatternLine(0, 30, 300, 30, &PatternSlashDotSlash);
	w1->WindowPatternLine(0, 50, 300, 50, &PatternSlash);

			w1->set_fcolor(CBLUE);
			w1->set_ppop(_GCOLORKEY);
			w1->printf(20, 40, "  You can minimize this window! \n");
			w1->printf(0, 0, "and restore with right button again!\n");
			w1->set_ppop(_GSET);
/*
	FGPixel *bm = (FGPixel *)malloc(areasize(X_width,Y_width));
	FGmemset(bm, (FGPixel)0x0300, (X_width*Y_width));
	int rrr=clock();
	AlphaBlit(bm, bm, (X_width*Y_width), 120);
	AlphaBlit(bm, bm, (X_width*Y_width),200);
	AlphaBlit(bm, bm, (X_width*Y_width),200);
	AlphaBlit(bm, bm, (X_width*Y_width),200);
	AlphaBlit(bm, bm, (X_width*Y_width),200);
	printf("Blit = %d\n", clock()-rrr);
	free(bm);


	rrr=clock();
	set_ppop(0);
	for(int g=0;g<200;g++)
	{
		set_fcolor(g);
//		fill_box(0, 0, 800, 600);
	}
	for(int g=0;g<1000;g++)
	{
		set_fcolor(g);
		draw_line(0, 0, 800, g);
		draw_line(799, 0, 0, g);
	}
//	printf("Hw Blit = %d\n", clock()-rrr);
*/
	draw_line(0,0,800,600,CRED,0);
	w1->set_ppop(_GXOR);
	w1->WindowLine(-10,-10,3000,2000);
	w1->WindowFillCircle(400,160,60,CRED);
	w1->set_ppop(0);
	MyApp.SetTimerProc(0,10);
/*
	FGRect r;
	r.x = r.y = 0;
	r.w = r.h = 100;

	GLSurface aa(w2, &r);
	aa.MakeCurrent();
	aa.Draw();
	aa.Draw();
	aa.Draw();
*/
	w2->AddCheckButton(60, 48,"asd");
	w2->AddPointButton(60, 30,"asd");
	FGBitmap bmp(64,23, CWHITED);
	FGPushButton *bbb = w2->AddPushButton(0,100,0,&bmp,0);
	bbb->SetName("fed");

	w2->AddTabPage("Prva");
	FGWidgetContainer cont;
	FGControl* pp6 = eb = w2->AddPushButton(20, 10, 60, 24, "Test", 'T', test);
	cont.AddToContainer(eb);
	eb = w2->AddSlideBarH(20, 40, -10, -20, 1, &aa);
//	eb->Disable();
	cont.AddToContainer(eb);
//	cont.DisableContainer();
//	aa = w2->ShowModal();
	w2->AddTabPage("Druhy");
	w2->AddTabPage("Tri00");
	w2->AddTabPage("Stvrty");
	w2->SetTabPage("Prva");

	w2->DeleteTabPage("Druhy");

//	pp6->Disable();

	FGEditBox *e = w1->AddEditBox(10,200,50,50,"gdfg22",0,&aa);
	w1->AddEditBox(10,230,50,50,"gdfgfd",0,&aaz);
	new FGUpDown(e, 2);

	w2->WindowShape(300,200,200,200);
/*
	unsigned short uu[10]={'d', 'o', 'm', 'a', ' ', 'j', 'e', 0};
	FGFontProperty f("verdana.ttf", 43);
	f.Bold(true);
	f.Underline(true);
	f.Shaded();
	w2->WindowTextUnicode(30,60,uu, &f, 0,CWHITE);
	f.Shaded();
	w2->WindowTextUnicode(30,90,uu, &f, 0,CWHITE);
*/
	w2->WindowFillTriangle(10,10,100,100,300,150);
//	w1->WindowBox(0,0,3000,520);
	FGTextEditor *ed = new FGTextEditor(&ed, "Untitled");
	text_out(0,0,"fdsafsdgsdgdsgdfgds",0,CWHITE,0,5);
	for(i=0;i<256;i++)
	{
		w1->WindowBox((i&15)*16, (i/16)*16, 16,16,FGCOLOR(i));
	}
	w1->AddLabel(260,0,"label", 'l');
	w1->AddPanel(8, 8, 1504, 1584, " Vyska ");
	w1->AddText(0, 0, " DYNAMICKY TEXT ", CRED,CBLUE);
	w1->set_ppop(0);
	w1->WindowLine(0,420, 600, 560, CBLUE);
	for(i=-100;i<2000;i++)
	{
		w1->WindowLine(i,i+200, i+200, i, CRED);
	}
	FGApp::SetCaption("fdsfsaf");
	w1->WindowDrawCircle(100,100, 200, CRED);
//	Bitmap *b = new Bitmap("mrp.tif");
//	w1->WindowPutBitmap(0,0,0,0,1500,1500,b);
	char *strings[] = { "string one", "string two", "string three", "string four", 0 };
	int rg0=0;
	FGRadioGroupHorizontal* rg = new FGRadioGroupHorizontal(40, 40, strings, &rg0, 0, w1, 96);
	rg0=2;
	rg->ChangeItem(&rg0);
//	new FGRadioGroupVertical(40, 80, strings, 0, 0, w1, 20);

	new FGFontDialog(ss, 3);

	new FGFileDialog(filesel, 0, 0, "Save file", FDIALOG_SAVE);

	MyApp.SetDelayProc(klavesy);
//	MyApp.SetTimerProc(timer, 200);
	FGDialog aaa(CYELLOW, CBLUE, "Chyba!", "Coooo ???");
//	aaa.ShowYesNo();

	FGBitmap obr;
	FGBitmap::ReturnValues val;
	val = obr.LoadImage("z_kopy.gif");
	obr.JpegSave("z_kopyska.jpegf");
	FGApp::GetRootWindow()->WindowPutBitmap(0, 0, 0,0,X_width, Y_width, &obr);

	MyApp.Run(app);

//	delete ed;
	delete w1;
	delete w2;

	cCfg->WriteInt("a", aa);
	cCfg->WriteInt("A", aa);
	cCfg->WriteInt("b", aa);
	cCfg->WriteInt("s", aa);
	cCfg->WriteInt("z", aa);
	cCfg->Sort();
	return 0;
}


