//---------------------------------------------------------------------------
#include <qpthr/qp.h>
#include "../fastgl.h"
#include <sched.h>

#pragma hdrstop

//---------------------------------------------------------------------------
using namespace qpthr;


class ThreadKresliDoOkna : public QpThread
{
  public:
    ThreadKresliDoOkna(Window* Wnd, FGPixel Farba) : mWnd(Wnd), mFarba(Farba) {}
    virtual void Main();
  private:
    Window* mWnd;
    FGPixel mFarba;
};


void ThreadKresliDoOkna::Main()
{
  Sleep(rand() % 2000);
  while (true)
  {
    switch (rand() % 7)
    {
      case 1:
        mWnd->WindowRect(rand() % mWnd->GetW(), rand() % mWnd->GetH(), rand() % 100, rand() % 100, mFarba);
        break;
      case 2:
//		mWnd->WindowDrawCircle(rand() % mWnd->GetW(), rand() % mWnd->GetH(), rand() % 100, mFarba);
		break;
	  case 3:
		mWnd->WindowFillCircle(rand() % mWnd->GetW(), rand() % mWnd->GetH(), rand() % 100, mFarba);
		break;
	  case 4:
		mWnd->WindowFillEllipse(rand() % (mWnd->GetW() - 100), rand() % (mWnd->GetH() - 100), rand() % 100, rand() % 100, mFarba);
		break;
	  case 5:
		mWnd->WindowDrawEllipse(rand() % (mWnd->GetW() - 100), rand() % (mWnd->GetH() - 100), rand() % 100, rand() % 100, mFarba);
		mWnd->WindowText(rand() % mWnd->GetW(), rand() % mWnd->GetH(), "TEXTISKO", mFarba);
		break;
	  case 6:
//        mWnd->bitblit(100, 0, 0, 0, mWnd->GetW() - 100, mWnd->GetH(), mWnd, BITBLIT_WITH_DECREMENT);
        break;
      default:
        mWnd->WindowBox(rand() % mWnd->GetW(), rand() % mWnd->GetH(), rand() % 100, rand() % 100, mFarba);
    }

    TestCancel();
    sched_yield();
	Sleep(rand() % 20 + 5);
  }
}


int AppProc(GuiEvent* p)
{
  return 1;
}


#pragma argsused
int mains(int argc, char* argv[])
{
  QpInit qp_init;
  App MyApp(G1024x768, argc, argv, CBLUE, APP_ROOTWINDOW | APP_ENABLEALTX | APP_LOCALDIR);

  srand(time(NULL));

  ThreadKresliDoOkna* Thread[2048];
  int ThreadCount = 0;

  for (int i = 0; i < 2; i++)
  {
	char title[20];
	sprintf(title, "Okno %d", i);
	Window* Wnd = new Window(&Wnd, rand() % (MyApp.GetRootWindow()->GetW() - 200), rand() % (MyApp.GetRootWindow()->GetH() - 200), rand() % 400 + 200, rand() % 400 + 200, title, GuiHwnd(NULL), CWHITED, CBLACK, WFRAMED | WTITLED | WSIZEABLE | WMINIMIZE);
	//Wnd->set_font...

	FGPixel Farba = rand() % 0xFFFFFF;
	for (int i = 0; i < 4; i++)
	{
	  //FGPixel Farba = rand() % 0xFFFFFF;
	  Thread[ThreadCount++] = new ThreadKresliDoOkna(Wnd, Farba);
	}
  }

  MyApp.GetRootWindow()->printf("Pocet threadov: %d\n", ThreadCount);

  for (int i = 0; i < ThreadCount; i++) Thread[i]->Start();

  MyApp.Run(AppProc);

  for (int i = 0; i < ThreadCount; i++)
  {
    Thread[i]->Cancel();
    Thread[i]->Join();
    delete Thread[i];
  }

  return 0;
}
//---------------------------------------------------------------------------

